<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Mail\Mailable;
use Illuminate\Mail\Mailables\Content;
use Illuminate\Mail\Mailables\Envelope;
use Illuminate\Queue\SerializesModels;

class VehicleEntryMail extends Mailable
{
    use Queueable, SerializesModels;

    public $scheduleType;

    public $tableData;

    public $mailSubject;

    /**
     * Create a new message instance.
     */
    public function __construct($scheduleType, $tableData, $mailSubject)
    {
        $this->scheduleType = $scheduleType;
        $this->tableData = $tableData ?? [];
        $this->mailSubject = $mailSubject ?? 'Vehicle Entry Report';
    }

    /**
     * Get the message envelope.
     */
    public function envelope(): Envelope
    {
        return new Envelope(
            subject: 'Vehicle Entry Mail',
        );
    }

    /**
     * Get the message content definition.
     */
    public function content(): Content
    {
        $greeting = '<b>Dear Sir</b>';

        //$greeting1 = 'Dear C.R.I Branch Team, <br><br> Please follow and ensure the same';

        if ($this->scheduleType == 'Daily') {
            $reportPeriod = "";
            $greeting .= $reportPeriod;
        }

        if ($this->scheduleType == 'Hourly') {
            $now = now();
            $fromHour = $now->copy()->subHour()->format('H:i:s');
            $toHour = $now->format('H:i:s');
            $reportDate = $now->format('d/m/Y');
            $greeting .= "from: $reportDate, $fromHour to $toHour. <br><br>Please arrange to receipt the same immediately.";
        }

        if ($this->scheduleType == 'Live') {
            $now = now();
            $fromMinute = $now->copy()->subMinute()->format('d/m/Y H:i:s');
            $toMinute = $now->format('d/m/Y H:i:s');
            $greeting .= "from: $fromMinute to $toMinute. <br><br>Please arrange to receipt the same immediately.";
        }

        return new Content(
            view: 'mail.vehicle_entry_report',
            with: [
                'company' => 'CRI Digital Manufacturing Solutions',
                'greeting' => $greeting,
                'tableData' => $this->tableData,
                'wishes' => 'Thanks & Regards,<br>CRI Digital Manufacturing Solutions',
            ],
        );
    }
    /**
     * Get the attachments for the message.
     *
     * @return array<int, \Illuminate\Mail\Mailables\Attachment>
     */
    public function attachments(): array
    {
        return [];
    }
}
